
#include <sourcemod>
#include <tf2>
#include <tf2_stocks>
#include <menus>
#include <entity>

#define PLUGIN_VERSION "1.0.0.0"
#define MAX_CHAT_TRIGGERS		15
#define MAX_CHAT_TRIGGER_LENGTH 15
#define PLAYER_TIMESTAMP		1
#define PLAYER_STATUS			0
#define MVMSONG	"music/mvm_start_wave.wav"
#define FINALWAVE1 "vo/mvm_final_wave_start01.wav"
#define FINALWAVE2 "vo/mvm_final_wave_start02.wav"
#define FINALWAVE3 "vo/mvm_final_wave_start03.wav"
#define END5	"vo/announcer_ends_5sec.wav"
#define END4	"vo/announcer_ends_4sec.wav"
#define END3	"vo/announcer_ends_3sec.wav"
#define END2	"vo/announcer_ends_2sec.wav"
#define END1	"vo/announcer_ends_1sec.wav"

new g_iTriggers = 0; // Chat Triggers
new String:chatTriggers[MAX_CHAT_TRIGGERS][MAX_CHAT_TRIGGER_LENGTH]; // Chat Triggers
new TrackPlayers[MAXPLAYERS+1][5];
new Handle:c_Cooldown = INVALID_HANDLE;
new bool:RoundStarted;
new Handle:TimerHandle[MAXPLAYERS + 1];
new Handle:TempH=0;
new PathSpot = 0;
new Handle:HUDDisplay;
new Handle:HUDDHealth;
new GameRound = 0;
new RoundTimer = 20;
new Handle:Timer2H = INVALID_HANDLE;
new Handle:HUDDCount;

new bool:SoundPlayed = false;
new bool:SoundPlayed2 = false;
new bool:SoundPlayed3 = false;
new bool:SoundPlayed4 = false;
new bool:SoundPlayed5 = false;
new bool:SoundPlayed6 = false;

new bool:TimerCounter = false;
new bool:IsKilled = false;
new bool:IsTankAlive = false

public Plugin:myinfo =
{
    name = "Tank Mini-game (Trade Rawr only)",
    author = "Starman4xz",
    description = "Tank Mini-game",
    version = PLUGIN_VERSION,
    url = "http://sourcemod.net"
}

public OnPluginStart()
{
	RegConsoleCmd("say", Command_Chatparse);
	RegConsoleCmd("say_team", Command_Chatparse);
    //ServerCommand("sm_tankgame");
    c_Cooldown = CreateConVar("sm_minigame_wait", "20", "Sets the wait-time till another Mini-game can be called.");
    HookEvent("teamplay_broadcast_audio", Event_StopTimer2);
    HUDDisplay = CreateHudSynchronizer();
    HUDDHealth = CreateHudSynchronizer();
    HUDDCount = CreateHudSynchronizer();
}

public OnMapStart()
{
PrecacheSound(MVMSONG, true);
PrecacheSound(FINALWAVE1, true);
PrecacheSound(FINALWAVE2, true);
PrecacheSound(FINALWAVE3, true);

PrecacheSound(END5, true);
PrecacheSound(END4, true);
PrecacheSound(END3, true);
PrecacheSound(END2, true);
PrecacheSound(END1, true);
}

public Action:Command_Chatparse(client, args)
{
if(client <= 0 || !IsClientInGame(client)) return Plugin_Continue; 
	
	decl String:strMessage[128];
	GetCmdArgString(strMessage, sizeof(strMessage));
	
	
	new startidx = 0;
	if(strMessage[0] == '"')
	{
		startidx = 1;
		new len = strlen(strMessage);
		
		if(strMessage[len-1] == '"') strMessage[len-1] = '\0';
	}
	
	new bool:cond = false;
	for(new i=0; i<g_iTriggers; i++)
	{
		if(StrEqual(chatTriggers[i], strMessage[startidx], false))
		{
			cond = true;
			continue;
		}
	}
	
	if(StrEqual("!votetank", strMessage[startidx], false)) cond = true;
	
	if(!cond) return Plugin_Continue;
	
	if(RoundStarted == true)
	{
		PrintToChat(client, "[SM] Tank Mini-game has already started.");
		return Plugin_Handled;
	}
	
	new timeleft = GetTime() - TrackPlayers[client][PLAYER_TIMESTAMP];
	if(TrackPlayers[client][PLAYER_TIMESTAMP] > 0 && timeleft < GetConVarInt(c_Cooldown))
		{
		PrintToChat(client, "[SM] You cannot start another Tank Mini-game yet.");	
		return Plugin_Handled;
		}
		
	
	if(cond)
	{
	StartTankVote(client);
	PrintToChat(client, "[SM] Tank Mini-game vote is now being started.");
	return Plugin_Continue
	}
	
	new bool:reset = false;
	for(new i=0; i<g_iTriggers; i++)
	{
		if(StrEqual(chatTriggers[i], strMessage[startidx], false))
		{
			reset = true;
			continue;
		}
	}
	
	if(StrEqual("!votereset", strMessage[startidx], false)) reset = true;
	
	if(!reset) return Plugin_Continue;
	
	if(reset)
	{
	StartTankVoteReset(client);
	PrintToChat(client, "[SM] Vote to reset the Tank-Minigame is now starting.");
	return Plugin_Continue
	}
	
	
	
	return Plugin_Handled;
}

public Handle_VoteMenu(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		/* This is called after VoteEnd */
		CloseHandle(menu);
	} else if (action == MenuAction_VoteEnd) {
		/* 0=yes, 1=no */
		if (param1 == 0)
		{
			PrintToChatAll("[SM] Tank mini-game won the vote! Starting...");
			Command_StartMinigame();
			RoundStarted = true;
		}
	}
}
 
StartTankVote(client)
{
	if (IsVoteInProgress())
	{
		return;
	}
 
	new Handle:menu = CreateMenu(Handle_VoteMenu);
	SetMenuTitle(menu, "A vote has been started for the Tank-Minigame!");
	AddMenuItem(menu, "yes", "Yes");
	AddMenuItem(menu, "no", "No");
	SetMenuExitButton(menu, false);
	VoteMenuToAll(menu, 20);
}

public Handle_VoteMenu2(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_End)
	{
		/* This is called after VoteEnd */
		CloseHandle(menu);
	} else if (action == MenuAction_VoteEnd) {
		/* 0=yes, 1=no */
		if (param1 == 0)
		{
			PrintToChatAll("[SM] The reset won the vote! Resetting...");
			GameRound = 0;
			Command_StartMinigame();
			RoundStarted = true;
		}
	}
}

StartTankVoteReset(client)
{
	if (IsVoteInProgress())
	{
		return;
	}
 
	new Handle:menu = CreateMenu(Handle_VoteMenu2);
	SetMenuTitle(menu, "A vote has been started to reset the Tank-Minigame");
	AddMenuItem(menu, "yes", "Yes");
	AddMenuItem(menu, "no", "No");
	SetMenuExitButton(menu, false);
	VoteMenuToAll(menu, 20);
}

public Command_StartMinigame()
{
	new Pathtrack = CreateEntityByName("path_track");
	if (IsValidEdict(Pathtrack))
	{
	new Float:pos[3]; pos[0] += 16.0;	pos[1] += 1112.0;	pos[2] += -15.0;
	//PrintToChatAll("Pos: %f, %f, %f", pos[0], pos[1], pos[2]);
	TeleportEntity(Pathtrack, pos, NULL_VECTOR, NULL_VECTOR);
	
	DispatchKeyValue(Pathtrack, "targetname", "boss_path_1");
	
	
	DispatchSpawn(Pathtrack);
	ActivateEntity(Pathtrack);
	}
	
	 if (GameRound < 11)
	 {
	 GameRound++
	 }
	 
	 	 
	
	
	Command_BuildTank()
	EmitSoundToAll(MVMSONG);
	for(new i=1; i<=MaxClients; i++)
	{
		if(!IsClientInGame(i) || !IsPlayerAlive(i)) continue;
		{
			FakeClientCommandEx(i, "voicemenu 2 1");
		}
	}
	
	Command_ResetPath()
		
	
}

public Action:Command_BuildTank()
{
	new Tank_boss = CreateEntityByName("tank_boss");
	if (IsValidEdict(Tank_boss))
	{
	new Float:tankpos[3]; tankpos[0] += 1022.0;	tankpos[1] += 220.0;	tankpos[2] += 15.0;
	//PrintToChatAll("Pos2: %f, %f, %f", tankpos[0], tankpos[1], tankpos[2]);
	
	
	SetVariantInt(500 + GameRound * 800); 
	AcceptEntityInput(Tank_boss, "SetHealth");
	
	DispatchKeyValue(Tank_boss, "TeamNum", "1");
	
	
	
	DispatchSpawn(Tank_boss);
	ActivateEntity(Tank_boss);
	
	TeleportEntity(Tank_boss, tankpos, NULL_VECTOR, NULL_VECTOR);
	RoundStarted = true;
	IsTankAlive = true;
	}
	
	//for(new i=1; i<=MaxClients; i++)
	//{
	if (TempH==0) {
	TempH = CreateTimer(0.0, Command_ControllMinigame,_, TIMER_REPEAT);
	//TimerHandle[i] = TempH;
	//PrintToChatAll("%i", TempH);
	}
	//}
	
	
}

public Action:Command_ControllMinigame(Handle:timer)
{
		
     		new index;
     		new tankindex;
     		for (new i = MaxClients+1; i <= 2048; i++)
			{
				if (!IsValidEntity(i)) continue;
				decl String:cls[25];
				GetEntityClassname(i, cls, sizeof(cls));
				if (!StrEqual(cls, "path_track")) continue;
				index = i
				 break;
			}
			for (new i = MaxClients+1; i <= 2048; i++)
			{
				if (!IsValidEntity(i)) continue;
				decl String:cls[25];
				GetEntityClassname(i, cls, sizeof(cls));
				if (!StrEqual(cls, "tank_boss")) continue;
				tankindex = i
				 break;
			}
     			
     			new Float:vec[3];
				GetEntPropVector(index, Prop_Data, "m_vecOrigin", vec);
	
				new Float:pos[3];
				GetEntPropVector(tankindex, Prop_Send, "m_vecOrigin", pos);
				
				new Float:distance = GetVectorDistance(vec, pos);
				
				if(distance < 100 && PathSpot == 0)
				{
				new Float:Newpos[3];	Newpos[0] = -617.0;	Newpos[1] = 578.0;	Newpos[2] = -15.0;
				TeleportEntity(index, Newpos, NULL_VECTOR, NULL_VECTOR);
				//PrintToChatAll("PathSpot1 Ended up with %i", PathSpot);
				CreateTimer(Float: 1.0, Command_Track);
				}
				if(distance < 50 && PathSpot == 1)
				{
				new Float:Newpos[3];	Newpos[0] = -40.0;	Newpos[1] = 23.0;	Newpos[2] = -15.0;
				TeleportEntity(index, Newpos, NULL_VECTOR, NULL_VECTOR);
				CreateTimer(Float: 1.0, Command_Track);
				//PrintToChatAll("PathSpot2 Ended up with %i", PathSpot);
				}
				if(distance < 50 && PathSpot == 2)
				{
				new Float:Newpos[3];	Newpos[0] = 694.0;	Newpos[1] = 486.0;	Newpos[2] = -15.0;
				TeleportEntity(index, Newpos, NULL_VECTOR, NULL_VECTOR);
				CreateTimer(Float: 1.0, Command_Track);
				//PrintToChatAll("PathSpot3 Ended up with %i", PathSpot);
				CreateTimer(Float: 1.0, Event_StopTimer);
				}
				if(distance < 30 && PathSpot == 3 && IsKilled == false)
				{
				CreateTimer(Float:8.5, Command_Kill);
				IsKilled = true;
				}
				
				
     			
   				SetHudTextParams(Float:-1.0, Float:-0.80, 1.1, 0, 255, 0, 255);
				for(new i = 1; i <= MaxClients; i++)
				{
					if(IsValidClient(i) && !IsFakeClient(i))
					{
						if (GameRound <= 10 && RoundStarted == true)
						{
							ShowSyncHudText(i, HUDDisplay, "Wave %i of 10", GameRound);
						}
						
						
					}
				}   				
     			SetHudTextParams(Float:-1.0, Float:-0.70, 1.1, 0, 255, 0, 255);
				for(new i = 1; i <= MaxClients; i++)
				{
					if(IsValidClient(i) && !IsFakeClient(i))
					{
						if (GameRound <= 10 && RoundStarted == true)
						{
							new Health = 500 + GameRound * 800;
						
							ShowSyncHudText(i, HUDDHealth, "Tank Maxhealth: %i", Health);
						}				
					}
				}
				
				SetHudTextParams(Float:-1.0, Float:0.80, 1.1, 0, 255, 0, 255);
				for(new i = 1; i <= MaxClients; i++)
				{
					if(IsValidClient(i) && !IsFakeClient(i))
					{
						if (GameRound <= 10 && RoundStarted == true)
						{
									
							ShowSyncHudText(i, HUDDCount, "Next Round in: %i", RoundTimer);
						}
												
					}
				}
				new String:TempEnt[32];
				GetEntityClassname(tankindex, TempEnt, sizeof(TempEnt));
				
				
				if (StrEqual(TempEnt, "worldspawn"))
				{
					if (RoundStarted == true && TimerCounter == false)
					{
						CreateTimer(Float:0.0, Command_TimerCount2);
						TimerCounter = true;
						IsTankAlive = false;
					}
				}
				
				if (RoundTimer == 0 && StrEqual(TempEnt, "worldspawn") && IsTankAlive == false)
				{
					for(new i = 1; i <= MaxClients; i++)
					{
				
						CloseHandle(Timer2H);
						Timer2H = INVALID_HANDLE;
						ClearSyncHud(i, Handle:HUDDCount);
						Command_StartMinigame();
						RoundTimer = 30;
						TimerCounter = false;
						SoundPlayed2 = false;
						SoundPlayed3 = false;
						SoundPlayed4 = false;
						SoundPlayed5 = false;	
						SoundPlayed6 = false;
					}
				}
				
			
				
				
     }
     		
public Action:Command_Track(Handle:timer)
{
PathSpot++
}
		
public Action:Event_StopTimer(Handle:timer)
{
	//PrintToChatAll("stoptimer");
	//for(new i=1; i<=MaxClients; i++)
	//{
	//PrintToChatAll("%i", TimerHandle[i]);
	//CloseHandle(TimerHandle[i]);
	//RoundStarted = false;
	//}
   	
}

public Action:Command_ResetPath()
{
	   	
   	
	new index = -1;
 	while ((index = FindEntityByClassname(index, "path_track")) != -1)
    {	
		new Float:pos[3]; pos[0] += 16.0;	pos[1] += 1112.0;	pos[2] += -15.0;
		TeleportEntity(index, pos, NULL_VECTOR, NULL_VECTOR);
		PathSpot = 0;
	}
}

public Action:Event_StopTimer2(Handle:event, const String:name[], bool:dontBroadcast)
{
	
					
			
				decl String:sound[20];
				GetEventString(event, "sound", sound, sizeof(sound));
	
				if (StrEqual(sound, "Announcer_MVM.General_Destruction"))
				{
					PrintToChatAll("Yes! It died!");
				
				}
		

    

  	

}

stock bool:IsValidClient(client) // Using this from FlaminSarge's code. This thing looks bloody usefull.
{
	if (client <= 0) return false; 
	if (client > MaxClients) return false;
//	if (!IsClientConnected(client)) return false;
	return IsClientInGame(client);
}

public Action:Event_Round(Handle:timer)
{
GameRound++
Command_StartMinigame()
}



public Action:Command_TimerCount2(Handle:timer)
{
Timer2H = CreateTimer(Float:1.0, Command_TimerCount3, _, TIMER_REPEAT);
}

public Action:Command_TimerCount3(Handle:timer)
{
	RoundTimer--;
	
	for(new i = 1; i <= MaxClients; i++)
	{
		
	
		if (RoundTimer == 0)
		{
			if (Timer2H != INVALID_HANDLE)
			{
				CloseHandle(Timer2H);
				Timer2H = INVALID_HANDLE;
				ClearSyncHud(i, Handle:HUDDCount);
				Command_StartMinigame();
				RoundTimer = 30;
				TimerCounter = false;
				SoundPlayed2 = false;
				SoundPlayed3 = false;
				SoundPlayed4 = false;
				SoundPlayed5 = false;	
				SoundPlayed6 = false;				
			}
		}
	 
	 	 
	
	if (RoundTimer == 8 && GameRound == 9 && SoundPlayed == false)
	{
	
			EmitSoundToAll(FINALWAVE1);
			SoundPlayed = true;
	}	
	
	if (RoundTimer == 5 && SoundPlayed2 == false)
	{
	EmitSoundToAll(END5);
	SoundPlayed2 = true;
	}	
	
	if (RoundTimer == 4 && SoundPlayed3 == false)
	{
	EmitSoundToAll(END4);
	SoundPlayed3 = true;
	}
	
	if (RoundTimer == 3 && SoundPlayed4 == false)
	{
	EmitSoundToAll(END3);
	SoundPlayed4 = true;
	}
	
	if (RoundTimer == 2 && SoundPlayed5 == false)
	{
	EmitSoundToAll(END2);
	SoundPlayed5 = true;
	}
	
	if (RoundTimer == 1 && SoundPlayed6 == false)
	{
	EmitSoundToAll(END1);
	SoundPlayed6 = true;
	}	
	
	
	if (GameRound == 10)
	{
		if (Timer2H != INVALID_HANDLE)
		{
			CloseHandle(Timer2H);
			Timer2H = INVALID_HANDLE;
			ClearSyncHud(i, Handle:HUDDCount);
			RoundTimer = 30;
			GameRound = 0;
			RoundStarted = false;
			ClearSyncHud(i, Handle:HUDDHealth);
			ClearSyncHud(i, Handle:HUDDisplay);
			CloseHandle(TempH);
			TempH = 0;
			SoundPlayed = false;
			
		}
	}
	}
}

public Action:Command_Kill(Handle:timer)
{
	
	decl String:cls[25];
	new tankindex;
    for (new i = MaxClients+1; i <= 2048; i++)
	{
		if (!IsValidEntity(i)) continue;
		GetEntityClassname(i, cls, sizeof(cls));
		if (!StrEqual(cls, "tank_boss")) continue;
		tankindex = i
		break;
	}
	
	new String:TempEnt[32];
	GetEntityClassname(tankindex, TempEnt, sizeof(TempEnt));
				
				
	if (!StrEqual(TempEnt, "worldspawn"))
	{
	AcceptEntityInput(tankindex, "Kill");
	}
	
	for(new i = 1; i <= MaxClients; i++)
	{
		if(IsValidClient(i) && !IsFakeClient(i))
		{
			FakeClientCommand(i, "kill");
		
		
			
			ClearSyncHud(i, Handle:HUDDCount);
			RoundTimer = 20;
			GameRound = 0;
			RoundStarted = false;
			ClearSyncHud(i, Handle:HUDDHealth);
			ClearSyncHud(i, Handle:HUDDisplay);
			SoundPlayed = false;
			IsKilled = false;
		}
	}
	}




/*for (new i = MaxClients+1; i <= 2048; i++)	// Masters Method of FindEntityByClassname()
{
if (!IsValidEntity(i)) continue;
decl String:cls[25];
GetEntityClassname(i, cls, sizeof(cls));
if (!StrEqual(cls, "entity_classname")) continue;
// do stuff
// break;
}
*/